local constants = require 'constants'
local log = radiant.log.create_logger('BATT OBSERVER')

local ArmorBatteryObserver = class()

--Called first every time
function ArmorBatteryObserver:initialize()
	-- list all the saved variables
	self._sv.entity = nil
  self._entity_traces = {}
end

--Called once on creation
function ArmorBatteryObserver:create(entity)
	self._sv.entity = entity
   --radiant.entities.kill_entity (entity)
end

--Always called. If restore, called after restore.
function ArmorBatteryObserver:activate()
	self._entity = self._sv.entity
  self._log = radiant.log.create_logger('BATT OBSERVER')
                          :set_prefix('BATT_observer')
                          :set_entity(self._sv._entity)
end

function ArmorBatteryObserver:post_activate()
  self._target_table = radiant.entities.get_target_table(self._sv._entity, 'BATTERY OBSERVER')
  self._battery_listener = radiant.events.listen(self._entity, 'stonehearth:combat:battery', self, self._on_battery)
  self._battery_listener = radiant.events.listen(self._entity, 'stonehearth:combat:begin_melee_attack', self, self._on_battery)
end

function ArmorBatteryObserver:_on_battery(e)
	-- -- Check the armor's brittleness data
    --local armor_data = radiant.entities.get_equipped_item(entity, 'armor')
 --  	local brittle_data = radiant.entities.get_entity_data(armor_data, 'bastioneers:combat:brittle')
 --    -- Check if it is brittle
 --  	if not brittle_data then
 --      -- Ignore if not
 --    	return
 --  	end
  
  	-- Get the current brittleness level
  	-- local brittleness = brittle_data.durability
  
  	-- Lower the brittleness level
    -- brittleness = brittleness - 1

  	-- if brittleness <= 0 then
    	--radiant.entities.unequip_item (entity, armor_data)
      radiant.entities.kill_entity (entity)
end

function ArmorBatteryObserver:destroy()
  	if self._on_battery then
  	   self._on_battery:destroy()
  	   self._on_battery = nil
  	end
end

return ArmorBatteryObserver